{    var   : }
{ F, EPS }
Unit MNB3R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure MNB3R(N :Integer; M :Integer; var X :Array of Real;
                var F :Real; var G :Array of Real; EST :Real;
                var EPS :Real; LIMIT :Integer; var IERR :Integer;
                var H :Array of Real; var KOUNT :Integer; FUN :Proc_F1_MN;
                GRAD :Proc_F3_MN);

implementation

procedure MNB3R(N :Integer; M :Integer; var X :Array of Real;
                var F :Real; var G :Array of Real; EST :Real;
                var EPS :Real; LIMIT :Integer; var IERR :Integer;
                var H :Array of Real; var KOUNT :Integer; FUN :Proc_F1_MN;
                GRAD :Proc_F3_MN);
var
N1,II,J,K,I :Integer;
CONST_,OLDF,GNRM,AMBDA,OLDG,DY,HNRM,SNRM,FY,ALFA,FX,DX,T,Z,DALFA,
   W :Real;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160,_170,_180,_190,_200,_210,_220,_230,_240,_250,_260,_270,_280,_290,
_300,_305,_310,_320,_400,_420,_500;
begin

{ --------EYCOBHA MHMA }
{      METOOM ETEPA-PBCA }
{             APAMETP }
{      N     -PAMEPHOCT POCTPAHCBA }
{      M     -M=2*N }
{      X     -BEKTOP EPEMEHHX }
{      F     -HAEHE YHK }
{      G     -BEKTOP-PAEHT }
{      EST   -OEHKA CHY HAEH YHK }
{      EPS   -TOHOCT BCEH MHMYMA }
{      LIMIT -MAKCMAHOE CO TEPA }
{      IERR  -PHAK OKOHAH CETA: }
{          IERR=-1-HET CXOMOCT }
{          IERR=0-HAEH MHMYM, }
{          IERR=1-BOHEHO LIMIT TEPA }
{          IERR=2-HET MIN O HAPABEH }
{      H     -PAO MACCB H M }
{      KOUNT -BOHEHHOE CO TEPA }
{      FUN   -OPOPAMMA BCEH YHK }
{      GRAD  -OPOPAMMA BCEH PAEHTA }

{      -------------------------------------------------- }
CONST_ := 1.E+08;
FUN(X,F,EPS);
GRAD(X,G,EPS,0);
KOUNT := 0;
IERR := 0;
N1 := N+1;
{ -----HAAO KA (N+1) TEPA }

_10:
for II:=1 to N1 do
 begin
  KOUNT := KOUNT+1;
  OLDF := F;
  GNRM := 0.0;
  for J:=1 to N do
   begin
_20:
    GNRM := GNRM+G[J-1]*G[J-1];
   end;
  if ( GNRM <= 0.0 ) 
   then goto _420;
  if ( II > 1 ) 
   then goto _40;
  for J:=1 to N do
   begin
_30:
    H[J-1] := -G[J-1];
   end;
  goto _60;
_40:
  AMBDA := GNRM/OLDG;
  for J:=1 to N do
   begin
_50:
    H[J-1] := AMBDA*H[J-1]-G[J-1];
   end;
_60:
  DY := 0.0;
  HNRM := 0.0;
  for J:=1 to N do
   begin
    K := J+N;
    H[K-1] := X[J-1];
    HNRM := HNRM+Abs(H[J-1]);
_70:
    DY := DY+H[J-1]*G[J-1];
   end;
  if ( DY >= 0.0 ) 
   then goto _310;
_80:
  SNRM := 1.0/HNRM;
  FY := F;
{ -----OCK OTPEKA, COEPAEO MHMYM }
{      O HAPABEH H }

  ALFA := 2.0*(EST-F)/DY;
  AMBDA := SNRM;
  if ( ALFA <= 0.0 ) 
   then goto _100;
  if ( ALFA-AMBDA ) < 0
   then goto _90
   else if ( ALFA-AMBDA ) > 0
         then goto _100
         else goto _100;
_90:
  AMBDA := ALFA;
_100:
  ALFA := 0.0;
_110:
  FX := FY;
  DX := DY;
  for I:=1 to N do
   begin
{ -----A O APYMEHTY BO H }

_120:
    X[I-1] := X[I-1]+AMBDA*H[I-1];
   end;
  FUN(X,F,EPS);
  GRAD(X,G,EPS,0);
  FY := F;
  DY := 0.0;
  for I:=1 to N do
   begin
_130:
    DY := DY+G[I-1]*H[I-1];
   end;
  if ( DY ) < 0
   then goto _140
   else if ( DY ) > 0
         then goto _160
         else goto _280;
_140:
  if ( FY >= FX ) 
   then goto _160;
  AMBDA := AMBDA+ALFA;
  ALFA := AMBDA;
  if ( HNRM*AMBDA <= CONST_ ) 
   then goto _110;
_150:
  IERR := 2;
  goto _500;
{ -----KYECKA HTEPO HA OTPEKE, }
{      COEPAEM MIN }

_160:
  T := 0.0;
_170:
  if ( AMBDA = 0.0 ) 
   then goto _280;
  Z := 3.0*(FX-FY)/AMBDA+DX+DY;
  ALFA := EMax1(EMax1(Abs(Z),Abs(DX)),Abs(DY));
  DALFA := (Z*Z-DX*DY)/ALFA;
  DALFA := DALFA/ALFA;
  if ( DALFA >= 0.0 ) 
   then goto _200;
  for J:=1 to N do
   begin
    K := N+J;
_180:
    X[J-1] := H[K-1];
   end;
  FUN(X,F,EPS);
  GRAD(X,G,EPS,0);
_190:
  if ( IERR <> 0 ) 
   then goto _500;
  IERR := -1;
  goto _10;
_200:
  W := ALFA*Sqrt(DALFA);
  ALFA := (DY+W-Z)*AMBDA/(DY+2.0*W-DX);
  for I:=1 to N do
   begin
_210:
    X[I-1] := X[I-1]+(T-ALFA)*H[I-1];
   end;
  FUN(X,F,EPS);
  GRAD(X,G,EPS,0);
  if ( F > FX ) 
   then goto _220;
  if ( F <= FY ) 
   then goto _280;
_220:
  DALFA := 0.0;
  for I:=1 to N do
   begin
_230:
    DALFA := DALFA+G[I-1]*H[I-1];
   end;
  if ( DALFA >= 0.0 ) 
   then goto _260;
  if ( F-FX ) < 0
   then goto _250
   else if ( F-FX ) > 0
         then goto _260
         else goto _240;
_240:
  if ( DX = DALFA ) 
   then goto _280;
_250:
  FX := F;
  DX := DALFA;
  T := ALFA;
  goto _170;
_260:
  if ( FY <> F ) 
   then goto _270;
  if ( DY = DALFA ) 
   then goto _280;
_270:
  FY := F;
  DY := DALFA;
  AMBDA := AMBDA-ALFA;
  goto _160;
_280:
  T := 0.0;
  for J:=1 to N do
   begin
    K := J+N;
    H[K-1] := X[J-1]-H[K-1];
_290:
    T := T+Abs(H[K-1]);
   end;
  if ( KOUNT < N1 ) 
   then goto _300;
  if ( T <= EPS ) 
   then goto _305;
_300:
  if ( OLDF-F+EPS ) < 0
   then goto _190
   else if ( OLDF-F+EPS ) > 0
         then goto _310
         else goto _190;
_305:
  if ( GNRM-EPS ) < 0
   then goto _420
   else if ( GNRM-EPS ) > 0
         then goto _190
         else goto _420;
_310:
  OLDG := GNRM;
  if ( KOUNT >= LIMIT ) 
   then goto _400;
{ -----BOHEHO LIMIT TEPA }
_320:
  IERR := 0;
 end;
goto _10;

{ -----KOHE KA TEPA }
_400:
IERR := 1;
if ( GNRM-EPS ) < 0
 then goto _420
 else if ( GNRM-EPS ) > 0
       then goto _500
       else goto _420;
_420:
IERR := 0;
_500:
end;

end.
